/*
  LCD
    @omzn  2020/10/20
*/

#include <stdbool.h>
#include <stdint.h>
#include <math.h>
#include "inc/hw_i2c.h"
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "inc/hw_qei.h"
#include "inc/hw_timer.h"
#include "driverlib/rom.h"
#include "driverlib/gpio.h"
#include "driverlib/i2c.h"
#include "driverlib/systick.h"
#include "driverlib/interrupt.h"
#include "driverlib/pin_map.h"
#include "driverlib/sysctl.h"
#include "driverlib/uart.h"
#include "driverlib/pwm.h"
#include "driverlib/timer.h"

#include "driverlib/qei.h"
#include "utils/uartstdio.h"
#include "utils/uartstdio.c" //strong-arm method

#include "periphConf.h" //generated by PinMux

#include "my_util.h"
#include "my_i2c.h"

#include "buzzer.h"
#include "lcd_SB1602.h"

//*****************************************************************************
// Global variables
//*****************************************************************************
uint8_t face1[] = {SB1602_DATA_BURST, '(', 0xF3, 0xA5, 'w', 0xA5, 0xF4, ')'};
uint8_t face2[] = {SB1602_DATA_BURST, '(', 0xF4, 0xA5, 'w', 0xA5, 0xF3, ')'};
uint8_t msg1[] = {SB1602_DATA_BURST, 0xBC, 0xAC, 0xB7, 0xB0, 0xDD, '!'};
uint8_t msg2[] = {SB1602_DATA_BURST, 0xBC, 0xAE, 0xCE, 0xDE, '-', 0xDD};
uint8_t counter[] = {'C', 'N', 'T', ':'};
uint8_t sw_counter = 0;

//*****************************************************************************
//
// This function sets up UART0 to be used for a console to display information
// as the example is running.
//
//*****************************************************************************
void initConsole(void)
{
  // Enable GPIO port A which is used for UART0 pins.
  SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
  // Configure the pin muxing for UART0 functions on port A0 and A1.
  // This step is not necessary if your part does not support pin muxing.
  GPIOPinConfigure(GPIO_PA0_U0RX);
  GPIOPinConfigure(GPIO_PA1_U0TX);
  // Enable UART0 so that we can configure the clock.
  SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);
  // Use the internal 16MHz oscillator as the UART clock source.
  UARTClockSourceSet(UART0_BASE, UART_CLOCK_PIOSC);
  // Select the alternate (UART) function for these pins.
  GPIOPinTypeUART(GPIO_PORTA_BASE, GPIO_PIN_0 | GPIO_PIN_1);
  // Initialize the UART for console I/O.
  UARTStdioConfig(0, 9600, 16000000);
}

void initInterruptPins(void)
{
  clearSW1PinInt();
  GPIOIntRegister(GPIO_PORTF_BASE, SW1PinIntHandler);
  GPIOIntTypeSet(GPIO_PORTF_BASE, INT_ALL_BUTTONS, GPIO_FALLING_EDGE);
}

//*****************************************************************************
// Event handers
//*****************************************************************************

void SysTickIntHandler(void)
{
  static uint32_t tick_count = 0;
  uint8_t pin_state = 0;
  pin_state = GPIOPinRead();
  if (pin_state)
  {
    if ((tick_count % 32) == 0)
    {
      // 1 sec pushed ?
      sw_counter = 0;
    }
    tick_count++;
  }
  else
  {
    tick_count = 0;
  }
}

void SW1PinIntHandler(void)
{
  clearSW1PinInt();
  disableSW1PinInt();

  // do something
  sw_counter++;
  setAddressLCD(10, 1);
  writeTextLCD(sw_counter, 1);
}

int main(void)
{
  // Set the clocking to run directly from the crystal.
  ROM_SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                     SYSCTL_XTAL_16MHZ);
  // Set up ports hardware (see periphConf.c)
  PortFunctionInit();

  // Set up interrupts (you can specify GPIO interrupt initialization here)
  initInterruptPins();

  // Initialize console
  initConsole();
  UARTprintf("LCD example\n");

  // Initialize buzzer
  initBuzzer();

  // Initialize two I2C Masters
  initI2C(I2C3_BASE);
  // Initialize LCD module
  initLCD();

  enableSW1PinInt();

  setAddressLCD(1, 1);
  writeTextLCD(counter, 4);

  SysTickPeriodSet(SysCtlClockGet() / SYSTICKS_PER_SEC);
  SysTickEnable();
  SysTickIntRegister(SysTickIntHandler);
  SysTickIntEnable();

  while (1)
    ;
}
